const express = require("express");
const bunyan = require('bunyan');
const cors = require("cors");
const axios = require('axios');
const app = express();

app.use(cors(corsOptions));
app.use(express.json());
app.use(express.urlencoded({ extended: true }));

var corsOptions = {
  origin: "http://localhost:8081"
};

const log = bunyan.createLogger({ name: "AIR_Express" });

const predictURl = 'https://air-fastapi.azurewebsites.net/predict'

const input = {
  "Gender": 1,
  "BirthYear": 71,
  "LoanPeriod": 180,
  "Ats": "222718,093307,181210"
}

function calculateDataSizeInKb(data) {
  const size = new TextEncoder().encode(JSON.stringify(data)).length
  return size / 1024;
}

app.post("/home:ssn", (req, res) => {
  //To handle the SSN from the Search page
});

app.post("/home", (req, res) => {
  axios.post(predictURl, input).then(result => {
    log.info(`Data size from ML in Kb: `, calculateDataSizeInKb(result.data));
    res.json(result.data)
  }).catch(error => {
    log.error(`Home endpoint threw an exception: `, error)
  })
});

const PORT = process.env.PORT || 8080;
app.listen(PORT, () => {
  log.info(`Server is running on port ${PORT}.`);
});